//
//  MenuController.m
//  ICEDK Examples
//
//  Created by Icepat on 09/05/12.
//  Copyright (c) 2012 Icepat. All rights reserved.
//

#import "MenuController.h"
#import "ICEMutableSliderEngine.h"
#import "Constants.h"

@interface MenuController ()
// Configure the default cell.
- (UITableViewCell*)configureDefaultCellWithIndex:(NSUInteger)row;
@end

@implementation MenuController
@synthesize tableView = tableView_;

- (void)dealloc{
    [tableView_ release];
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewDidUnload
{
    [tableView_ release];
    tableView_ = nil;
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Common design application
// Common design application.
- (void)commonViewDesignApplication{
    [tableView_ setSeparatorStyle:UITableViewCellSeparatorStyleSingleLine];
    [tableView_ setSeparatorColor:[UIColor grayColor]];
}

#pragma mark - Cells configuration
// Configure the default cell.
- (UITableViewCell*)configureDefaultCellWithIndex:(NSUInteger)row{
    static NSString *CellIdentifier = @"CellIdentifier";
    UITableViewCell *cell = [tableView_ dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (!cell)
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    
    [cell setSelectionStyle:UITableViewCellSelectionStyleGray];
    
    switch (row) {
        case MENU_CONTROLLER_ROW_INFO:
            [[cell textLabel] setText:@"Welcome"];
            [[cell detailTextLabel] setText:@""];
            break;
        case MENU_CONTROLLER_ROW_RICH_LABEL:
            [[cell textLabel] setText:@"Rich Label"];
            [[cell detailTextLabel] setText:@""];
            break;
    }
    
    return cell;
}

#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 2;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{  
    return [self configureDefaultCellWithIndex:[indexPath row]];
}

#pragma mark - Table view delegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Post events.
    switch ([indexPath row]) {
        case MENU_CONTROLLER_ROW_INFO:
            // Send a notification (defined) to the Engine for switching the view.
            [ICEMutableSliderEvent postEventWelcome];
            break;
        case MENU_CONTROLLER_ROW_RICH_LABEL:
            // Send a notification (custom, with an ID) to the Engine for switching the view.
            [ICEMutableSliderEvent postEventCustom:MSEngineRemoteEventRichLabelController];
            break;
    }
}

@end
