//
//  RichLabelController.m
//  ICEDK Examples
//
//  Created by Icepat on 03/05/12.
//  Copyright (c) 2012 Icepat. All rights reserved.
//

#import "RichLabelController.h"
#import "ICERichTextLabel.h"
#import "ICERichTextStyle.h"

@interface RichLabelController ()
// Configure labels.
- (void)configureRichLabel;
// Handle taps on label.
- (void)handleTapOnLabel:(id)sender;
@end

@implementation RichLabelController

- (void)dealloc{
    [richLabel_ release];    
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // Configure label.
    [self configureRichLabel];
}

- (void)viewDidUnload
{
    [richLabel_ release];
    richLabel_ = nil;
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

#pragma mark - Labels
// Configure label.
- (void)configureRichLabel{
    // Set the styles.
    ICERichTextStyle *normalStyle = [ICERichTextStyle styleWithFont:[UIFont fontWithName:@"Helvetica" size:12.0]
                                                              color:[UIColor blackColor]
                                                          backColor:[UIColor clearColor]
                                                             prefix:nil
                                                         hidePrefix:NO];
    ICERichTextStyle *highLightStyle0 = [ICERichTextStyle styleWithFont:[UIFont fontWithName:@"Helvetica-Bold" size:12.0]
                                                                  color:[UIColor greenColor]
                                                              backColor:[UIColor grayColor]
                                                                 prefix:@"%"
                                                             hidePrefix:NO];
    ICERichTextStyle *highLightStyle1 = [ICERichTextStyle styleWithFont:[UIFont fontWithName:@"Helvetica-Bold" size:12.0]
                                                                  color:[UIColor redColor]
                                                              backColor:[UIColor clearColor]
                                                                 prefix:@"@"
                                                             hidePrefix:NO];
    ICERichTextStyle *highLightStyle2 = [ICERichTextStyle styleWithFont:[UIFont fontWithName:@"Helvetica-Bold" size:12.0]
                                                                  color:[UIColor purpleColor]
                                                              backColor:[UIColor clearColor]
                                                                 prefix:@"!"
                                                             hidePrefix:NO];
    ICERichTextStyle *highLightStyle3 = [ICERichTextStyle styleWithFont:[UIFont fontWithName:@"Helvetica-Bold" size:12.0]
                                                                  color:[UIColor blueColor]
                                                              backColor:[UIColor clearColor]
                                                                 prefix:@"#HASH"
                                                             hidePrefix:YES];    

    // Targets & selector.
    [highLightStyle0 addTarget:self action:@selector(handleTapOnLabel:)];
    [highLightStyle1 addTarget:self action:@selector(handleTapOnLabel:)];
    [highLightStyle2 addTarget:self action:@selector(handleTapOnLabel:)];    
    [highLightStyle3 addTarget:self action:@selector(handleTapOnLabel:)];
    
    // Set the rich label.
    ICERichTextLabel *label = [[ICERichTextLabel alloc] initWithWidth:richLabel_.frame.size.width];
    [label setStyle:normalStyle];
    [label addRichStyle:highLightStyle0];
    [label addRichStyle:highLightStyle1];
    [label addRichStyle:highLightStyle2];
    [label addRichStyle:highLightStyle3];    
    [label setLinkedObjects:[NSDictionary dictionaryWithObjectsAndKeys:@"ICEDK-OBJECT", @"icedk",
                             @"USING-OBJECT", @"@using",nil]];  
    [label setText:@"%Icepat thank you for @using his #HASHICEDK Repository.#HASHKEYicedk Follow me on !GitHub."];
    
    // Show it.
    [richLabel_ addSubview:label];
    
    [label release];
}

#pragma mark - Tap on label handler.
// Handle taps on label.
- (void)handleTapOnLabel:(id)sender{
	NSLog(@"\nText: %@\nTag : %i\nObject : %@\n", [sender text], [sender tag], [sender linkedObject]);
}


@end
