//
//  AppDelegate.m
//  ICEDK Examples
//
//  Created by Icepat on 03/05/12.
//  Copyright (c) 2012 Icepat. All rights reserved.
//

#import "AppDelegate.h"
#import "AboutController.h"
#import "MenuController.h"
#import "WelcomeController.h"
#import "RichLabelController.h"
#import "ICEMutableSliderEngine.h"

@interface AppDelegate()
// Configure the slider.
- (void)configureSliderEngine;
@end

@implementation AppDelegate
@synthesize window = window_;
@synthesize sliderEngine = sliderEngine_;

- (void)dealloc
{
    [window_ release];
    [sliderEngine_ release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    window_ = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] retain];
    
    // Configure the slider.
    [self configureSliderEngine];
    
     window_.rootViewController = sliderEngine_;
    [window_ makeKeyAndVisible];
    
    return YES;
}

// Configure the slider.
- (void)configureSliderEngine{
    // Load slider's panel controllers.
    MenuController *menuController = [[MenuController alloc] initWithNibName:@"MenuController" bundle:nil];
    AboutController *aboutController = [[AboutController alloc] initWithNibName:@"AboutController" bundle:nil];
    
    // Init the main navigation controller array.
    WelcomeController *welcomeController = [[WelcomeController alloc] initWithNibName:@"WelcomeController" bundle:nil];    
    RichLabelController *richLabelController = [[RichLabelController alloc] initWithNibName:@"RichLabelController" bundle:nil]; 
    
    // Init the array of "main" controllers.
    NSArray *rootControllers = [[[NSArray alloc] initWithObjects:welcomeController,richLabelController, nil] autorelease];
    
    // Load the slider engine.
    sliderEngine_ = [[[ICEMutableSliderEngine alloc] initWithRootControllers:rootControllers
                                                              leftController:menuController
                                                             rightController:aboutController//menuController
                                                                 andDelegate:nil] retain];
    // Clean.
    [menuController release];
    [aboutController release];
    [welcomeController release];
    [richLabelController release];
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
